<script setup lang="ts">
import { ref, nextTick, onMounted } from 'vue'
import type { VForm } from 'vuetify/components'

// store
import { useMaterialStore } from '@/stores/material'
import { useStockStore } from '../../stores/checkstock'
import { useStockBillStore } from '@/stores/stockbill'
import type { Stock } from '@/types/Stock'
import type { StockItem } from '@/types/StockItem'
import type { Material } from '@/types/Material'
const stockStore = useStockStore()
const materialStore = useMaterialStore()
const bill = useStockBillStore()
const form = ref(false)
const refForm = ref<VForm | null>(null)
const loading = ref(false)

//for Invoic
const invoiceDialog = ref(false)
const divReceiptItems = ref<HTMLElement | null>(null)

const selectedMaterial = ref<Material | undefined>()

function addMat() {
  if (selectedMaterial.value) {
    console.log('addMat: ', selectedMaterial.value)
    selected(selectedMaterial.value)
  } else {
    console.error('addMat: selectedMaterial is undefined')
  }
}

const selected = (material: Material) => {
  console.log('materialInv: ', material)
  if (material) {
    bill.addItem(material)
    nextTick(() => {
      if (divReceiptItems.value)
        divReceiptItems.value.scrollTo(0, divReceiptItems.value.scrollHeight)
    })
  }
}

const headerAddinvoice = [
  {
    title: 'ID',
    key: 'id',
    value: 'id'
  },
  {
    title: 'ชื่อ',
    key: 'name',
    value: 'name'
  },
  {
    title: 'จำนวน',
    key: 'amount',
    value: 'amount'
  },
  {
    title: 'ราคา',
    key: 'price',
    value: 'price'
  },
  {
    title: 'ลบ'
  }
]

function closeMaterialDialog() {
  materialStore.dialog = false
  nextTick(() => {
    materialStore.editMaterial = Object.assign({}, materialStore.initMaterial)
  })
}
onMounted(() => {
  materialStore.initialize()
})

async function saveMaterial() {
  const { valid } = await refForm.value!.validate()
  if (!valid) return

  const index = materialStore.materials.findIndex(
    (material) => material.id === materialStore.editMaterial.id
  )

  if (materialStore.editMaterial.id > -1) {
    console.log('update')
    materialStore.materials[index] = materialStore.editMaterial
  } else {
    console.log('new save')
    materialStore.editMaterial.id = materialStore.materials.length + 1
    materialStore.materials.push(materialStore.editMaterial)
  }

  closeMaterialDialog()
}

function onSubmit() {
  // Implement your form submission logic here
}
</script>

<template>
  <v-dialog v-model="bill.invDialog">
    <v-sheet border>
      <div class="d-flex align-center justify-end" style="padding: 5px">
        <v-btn
          @click="bill.clear"
          color="red-darken-4"
          icon="mdi-close-circle"
          size="small"
        ></v-btn>
      </div>
      <!-- title -->
      <div style="padding: 0px">
        <div class="align-center" style="padding-left: 20px">
          <h2 class="text-h4 font-weight-black">Stock Bill</h2>
          <p>บันทึกรายละเอียดการซื้อสินค้า</p>
        </div>
        <v-divider class="border-opacity-50"></v-divider>
      </div>

      <!-- detail of user -->
      <div style="padding: 5px; height: 70px">
        <v-row class="d-flex align-center justify-end">
          <v-avatar rounded="0" style="padding-top: 10px" size="50">
            <v-img :src="`src/image/user/user${bill.initStockBill.userID}.png`"></v-img>
          </v-avatar>
          <v-card-subtitle>
            ชื่อพนักงาน :
            {{ stockStore.getUserName(bill.initStockBill.userID) || 'Unknown User' }}
          </v-card-subtitle>
        </v-row>
        <v-row class="d-flex align-center justify-end">
          <v-card-subtitle
            >วันที่ : {{ stockStore.formatDate(bill.initStockBill?.creatDate) }}</v-card-subtitle
          >
        </v-row>
      </div>
      <v-divider class="border-opacity-50"></v-divider>
      <!-- addItem ti invoice -->
      <div style="padding: 5px; max-height: 85px">
        <v-row class="d-flex align-center justify-start">
          <v-col cols="3">
            <v-select
              style="padding-top: 12px"
              :item-title="(item) => item.name"
              :item-value="(item) => item"
              :items="materialStore.materials"
              :rules="[(v) => !!v || 'Item is required']"
              v-model="selectedMaterial"
              label="Item"
              required
            ></v-select>
          </v-col>

          <v-col cols="3">
            <v-text-field
              style="padding-top: 12px"
              v-model="bill.amount"
              :readonly="loading"
              :rules="[(v) => !!v || 'Field is required']"
              class="mb-2"
              type="number"
              clearable
              label="จำนวน"
            >
            </v-text-field>
          </v-col>
          <v-col cols="3">
            <v-text-field
              style="padding-top: 12px"
              v-model="bill.price"
              :readonly="loading"
              :rules="[(v) => !!v || 'Field is required']"
              class="mb-2"
              type="number"
              clearable
              label="ราคาต่อหน่วย"
            >
            </v-text-field>
          </v-col>

          <v-col cols="1" style="padding-top: 20px">
            <v-btn
              color="blue-lighten-1"
              icon="mdi-language-markdown"
              size="small"
              @click="addMat"
            ></v-btn>
          </v-col>

          <v-col cols="1" style="padding-top: 20px">
            <v-dialog
              v-model="materialStore.dialog"
              persistent
              width="500"
              style="padding-top: 20px"
            >
              <template v-slot:activator="{ props }">
                <v-btn color="blue-lighten-1" v-bind="props" icon="mdi-plus-box" size="small">
                </v-btn>
              </template>
              <v-card>
                <v-card-title>
                  <span class="text-h5">New Material</span>
                </v-card-title>
                <v-card-text>
                  <v-form ref="refForm" v-model="form" @submit.prevent="onSubmit">
                    <v-container>
                      <v-row>
                        <v-col cols="12" sm="12" md="4">
                          <v-text-field
                            v-model="materialStore.editMaterial.name"
                            :readonly="loading"
                            :rules="[(v) => !!v || 'Field is required']"
                            class="mb-2"
                            clearable
                            label="ชื่อวัตถุดิบ"
                          ></v-text-field>
                        </v-col>
                        <v-col cols="12" sm="12" md="4">
                          <v-text-field
                            v-model="materialStore.editMaterial.minimum"
                            :readonly="loading"
                            :rules="[(v) => !!v || 'Field is required']"
                            class="mb-2"
                            clearable
                            label="จำนวนขั้นต่ำ"
                          ></v-text-field>
                        </v-col>
                        <v-col cols="12" sm="12" md="4">
                          <v-text-field
                            v-model="materialStore.editMaterial.amount"
                            :readonly="loading"
                            :rules="[(v) => !!v || 'Field is required']"
                            class="mb-2"
                            clearable
                            label="จำนวนที่มีอยู่"
                          ></v-text-field>
                        </v-col>
                      </v-row>
                      <v-row>
                        <v-col cols="12">
                          <v-text-field
                            v-model="materialStore.editMaterial.type"
                            :readonly="loading"
                            :rules="[(v) => !!v || 'Field is required']"
                            class="mb-2"
                            clearable
                            label="หน่วยเรียก"
                            single-line
                          ></v-text-field>
                        </v-col>
                      </v-row>
                    </v-container>
                  </v-form>
                  <small>*indicates required field</small>
                </v-card-text>
                <v-card-actions>
                  <v-spacer></v-spacer>
                  <v-btn color="red-accent-3" variant="outlined" @click="closeMaterialDialog">
                    Close
                  </v-btn>
                  <v-btn color="blue-darken-1" variant="outlined" @click="saveMaterial">
                    Save
                  </v-btn>
                </v-card-actions>
              </v-card>
            </v-dialog>
          </v-col>
        </v-row>
      </div>
      <div style="padding: 5px" class="overflow-receipt-table">
        <v-card title="Invoice Items">
          <v-data-table-virtual
            :headers="headerAddinvoice"
            :items="bill.stockBillDetails"
            height="300"
            fixed-header
            hide-default-footer
            disable-pagination
            class="flex-table"
            overflow-y="hidden"
          >
            <template v-slot:item="{ item }">
              <tr>
                <td>{{ item.id }}</td>
                <td>{{ item.name }}</td>
                <td>{{ item.amount }}</td>
                <td>{{ item.price }}</td>
                <td>
                  <v-icon
                    icon="mdi-delete-circle"
                    size="large"
                    color="red"
                    @click="bill.deleteItem(item)"
                  ></v-icon>
                </td>
              </tr>
            </template>
          </v-data-table-virtual>

          <v-card height="40" md="6" width="100%">
            <v-row class="d-flex justify-start">
              <v-col>
                <v-card-sub-title
                  >จำนวนรวมทั้งหมด: {{ bill.initStockBill.totalItem }} รายการ</v-card-sub-title
                >
              </v-col>
              <v-col>
                <v-card-sub-title
                  >คิดเป็นเงินทั้งหมด: {{ bill.initStockBill.total }}</v-card-sub-title
                >
              </v-col>
              <v-col>
                <v-card-sub-title>ยอดที่จ่าย:</v-card-sub-title>
              </v-col>
              <v-col>
                <v-text-field
                  label=""
                  variant="outlined"
                  :rules="[(v) => !!v || 'Field is required']"
                  v-model="bill.initStockBill.paid"
                  type="number"
                  style="height: 45px"
                ></v-text-field>
              </v-col>
              <v-col>
                <div class="d-flex align-center justify-end">
                  <v-btn @click="bill.saveBill" color="primary">Save</v-btn>
                </div>
              </v-col>
            </v-row>
          </v-card>
        </v-card>
      </div>
      <v-divider class="border-opacity-50"></v-divider>
    </v-sheet>
  </v-dialog>
</template>

<style scoped>
.overflow-receipt-table {
  overflow-y: auto;
}
.overflow-receipt-table::-webkit-scrollbar {
  display: none;
}
</style>
@/types/StockIDetail../../stores/stock
